; ------------------------------------------------------
; Empty project
; Copyright (c) 2005-2006, Franck Charlet
; All rights reserved.
; ------------------------------------------------------
; buildblock RELEASE
;	CAPT %5\Release.bat
; buildblockend
; buildblock DEBUG
;	CAPT %5\Debug.bat
; buildblockend

; ------------------------------------------------------
; Constants
SCREEN_WIDTH 		equ	800
SCREEN_HEIGHT		equ	600
SCREEN_BPP		equ	32

; ------------------------------------------------------
; Includes
			include	..\Common_Src\FrameWork.asm
			include	..\Common_Src\Vertices.asm
			include	..\Common_Src\Ortho_Matrices.asm

; ------------------------------------------------------
; Variables
Star_Pos	VERTEX	<>
			real4 0.0

; ------------------------------------------------------
; Name: Initialize()
; Desc: Perform the various initializations
Initialize		proc

			invoke	glClearDepth, CDBL(1.0)
			invoke	glHint, GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST
			invoke	glClearColor, 0, 0, 0, CFLT(1.0)
			invoke	glEnable, GL_NORMALIZE
			invoke	glEnable, GL_CULL_FACE

		mov		eax, INT2FLT(SCREEN_WIDTH/2)
		mov		Star_Pos.x, eax
		mov		eax, INT2FLT(SCREEN_HEIGHT/2)
		mov		Star_Pos.y, eax
		
			mov	eax, TRUE
			ret
Initialize		endp

; ------------------------------------------------------
; Name: Deinitialize()
; Desc: Free allocated resources
Deinitialize		proc

			ret
Deinitialize		endp

; ------------------------------------------------------
; Name: Update()
; Desc: Update the scene
Update			proc	FrameRate:real4

			; Update scene here
			invoke	DInput_Get_Key, DIK_ESCAPE
			test	eax, eax
			jz	Esc_Pressed
			invoke	Terminate_Application
Esc_Pressed:		ret
Update			endp

; ------------------------------------------------------
; Name: Draw()
; Desc: Draw the scene
Draw			proc
			invoke	glClear, GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT or GL_STENCIL_BUFFER_BIT
			invoke  glClearColor, CFLT(0.0), CFLT(0.0), CFLT(0.0), CFLT(0.0)
			invoke	glDisable, GL_CULL_FACE
			invoke	glDisable, GL_DEPTH_TEST

	invoke	glPushMatrix
	invoke	Enter_2D_Mode, INT2FLT(SCREEN_WIDTH), INT2FLT(SCREEN_HEIGHT)
		invoke  glColor3f, CFLT(1.0), CFLT(1.0), CFLT(1.0)
		invoke  glTranslatef, CFLT(0.0), CFLT(0.0), CFLT(-1.0)
			invoke	glBegin, GL_POINTS
				invoke  glVertex2i,  FLT2INT(Star_Pos.x), FLT2INT(Star_Pos.y)
			invoke  glEnd
	invoke	Leave_2d_Mode
	invoke	glPopMatrix
 
			; Draw scene here

			ret
Draw			endp

end start
